Scriptname vibActorClothingSCT extends ReferenceAlias Hidden

int Property kSlotMask30 = 0x00000001 AutoReadOnly Hidden
int Property kSlotMask31 = 0x00000002 AutoReadOnly Hidden
int Property kSlotMask32 = 0x00000004 AutoReadOnly Hidden
int Property kSlotMask33 = 0x00000008 AutoReadOnly Hidden
int Property kSlotMask34 = 0x00000010 AutoReadOnly Hidden
int Property kSlotMask35 = 0x00000020 AutoReadOnly Hidden
int Property kSlotMask36 = 0x00000040 AutoReadOnly Hidden
int Property kSlotMask37 = 0x00000080 AutoReadOnly Hidden
int Property kSlotMask38 = 0x00000100 AutoReadOnly Hidden
int Property kSlotMask39 = 0x00000200 AutoReadOnly Hidden
int Property kSlotMask40 = 0x00000400 AutoReadOnly Hidden
int Property kSlotMask41 = 0x00000800 AutoReadOnly Hidden
int Property kSlotMask42 = 0x00001000 AutoReadOnly Hidden
int Property kSlotMask43 = 0x00002000 AutoReadOnly Hidden
int Property kSlotMask44 = 0x00004000 AutoReadOnly Hidden
int Property kSlotMask45 = 0x00008000 AutoReadOnly Hidden
int Property kSlotMask46 = 0x00010000 AutoReadOnly Hidden
int Property kSlotMask47 = 0x00020000 AutoReadOnly Hidden
int Property kSlotMask48 = 0x00040000 AutoReadOnly Hidden
int Property kSlotMask49 = 0x00080000 AutoReadOnly Hidden
int Property kSlotMask50 = 0x00100000 AutoReadOnly Hidden
int Property kSlotMask51 = 0x00200000 AutoReadOnly Hidden
int Property kSlotMask52 = 0x00400000 AutoReadOnly Hidden
int Property kSlotMask53 = 0x00800000 AutoReadOnly Hidden
int Property kSlotMask54 = 0x01000000 AutoReadOnly Hidden
int Property kSlotMask55 = 0x02000000 AutoReadOnly Hidden
int Property kSlotMask56 = 0x04000000 AutoReadOnly Hidden
int Property kSlotMask57 = 0x08000000 AutoReadOnly Hidden
int Property kSlotMask58 = 0x10000000 AutoReadOnly Hidden
int Property kSlotMask59 = 0x20000000 AutoReadOnly Hidden
int Property kSlotMask60 = 0x40000000 AutoReadOnly Hidden
int Property kSlotMask61 = 0x80000000 AutoReadOnly Hidden
Int[] kSlotMasks
Int Function kSlotMasks(Int aiBodySlot)
	Return kSlotMasks[aiBodySlot - 30]
EndFUnction

Form EquippedAmmo_var
Form Property EquippedAmmo Hidden
	Form Function Get()
		If (EquippedAmmo_var && !(GetReference() As Actor).isEquipped(EquippedAmmo_var))
			EquippedAmmo_var = None
		EndIf
		Return EquippedAmmo_var
	EndFunction
	Function Set(Form afValue)
		EquippedAmmo_var = afValue
	EndFunction
EndProperty

Form[] EquppedBodySlots
Form Function EquppedBodySlot(Int aiBodySlot)
	Int bodySlot = aiBodySlot - 30
	If (EquppedBodySlots[bodySlot] && !(GetReference() As Actor).isEquipped(EquppedBodySlots[bodySlot]))
		EquppedBodySlots[bodySlot] = None
	EndIf
	Return EquppedBodySlots[bodySlot]
EndFunction

Form EquippedLight_var
Form Property EquippedLight Hidden
	Form Function Get()
		If (EquippedLight_var && !(GetReference() As Actor).isEquipped(EquippedLight_var))
			EquippedLight_var = None
		EndIf
		Return EquippedLight_var
	EndFunction
	Function Set(Form afValue)
		EquippedLight_var = afValue
	EndFunction
EndProperty

Event OnInit()
	EquppedBodySlots = new Form[32]

	kSlotMasks = New Int[32]
	kSlotMasks[0] = kSlotMask30
	kSlotMasks[1] = kSlotMask31
	kSlotMasks[2] = kSlotMask32
	kSlotMasks[3] = kSlotMask33
	kSlotMasks[4] = kSlotMask34
	kSlotMasks[5] = kSlotMask35
	kSlotMasks[6] = kSlotMask36
	kSlotMasks[7] = kSlotMask37
	kSlotMasks[8] = kSlotMask38
	kSlotMasks[9] = kSlotMask39
	kSlotMasks[10] = kSlotMask40
	kSlotMasks[11] = kSlotMask41
	kSlotMasks[12] = kSlotMask42
	kSlotMasks[13] = kSlotMask43
	kSlotMasks[14] = kSlotMask44
	kSlotMasks[15] = kSlotMask45
	kSlotMasks[16] = kSlotMask46
	kSlotMasks[17] = kSlotMask47
	kSlotMasks[18] = kSlotMask48
	kSlotMasks[19] = kSlotMask49
	kSlotMasks[20] = kSlotMask50
	kSlotMasks[21] = kSlotMask51
	kSlotMasks[22] = kSlotMask52
	kSlotMasks[23] = kSlotMask53
	kSlotMasks[24] = kSlotMask54
	kSlotMasks[25] = kSlotMask55
	kSlotMasks[26] = kSlotMask56
	kSlotMasks[27] = kSlotMask57
	kSlotMasks[28] = kSlotMask58
	kSlotMasks[29] = kSlotMask59
	kSlotMasks[30] = kSlotMask60
	kSlotMasks[31] = kSlotMask61

EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If (akBaseObject As Armor)
		Int bodySlot = 31
		Int slotMask = (akBaseObject As Armor).GetSlotMask()
		While (bodySlot >= 0)
			If (slotMask / kSlotMasks[bodySlot] >= 1)
				slotMask = slotMask % kSlotMasks[bodySlot]
				EquppedBodySlots[bodySlot] = akBaseObject
			EndIf
			bodySlot -= 1
		EndWhile
	ElseIf (akBaseObject As Ammo)
		EquippedAmmo = akBaseObject
	ElseIf (akBaseObject As Light)
		EquippedLight = akBaseObject
	EndIf
EndEvent
