Scriptname vibMaintenanceSCT extends Quest Hidden

vibMUTEXSCT Property mutex Auto
vibMainSCT Property vibMainQST Auto

Actor Property PlayerREF Auto

Quest Property vibSleepQST Auto
Quest Property vibBedAliasFlipQST Auto
Quest Property vibBedAliasFlopQST Auto

Event OnInit()
	RegisterForSingleUpdate(1)
EndEvent

Event OnUpdate()
	If (vibMainQST.ResetControls)
		vibMainQST.ResetControls = False
		ResetControls()
	EndIf
	
	If (vibMainQST.Uninstall)
		vibMainQST.Stop()
		ResetControls()
	EndIf

	If (!vibMainQST.Uninstall)
		RegisterForSingleUpdate(1)
	EndIf
EndEvent

Function ResetControls()
	vibSleepQST.Stop()
	vibBedAliasFlipQST.Stop()
	vibBedAliasFlopQST.Stop()
	If (vibMainQST.BedAliasBuffer)
		vibMainQST.BedAliasBuffer.BlockActivation(False)
	EndIf
	Game.SetPlayerAIDriven(False)
	Game.EnablePlayerControls()
	PlayerREF.MoveTo(PlayerREF)
	vibMainQST.Dressup()
	mutex.unlockAll()
EndFunction
